diff -xMakefile.in -ru fluxbox-0.9.14.orig/nls/ru_RU/Makefile.am fluxbox-0.9.14/nls/ru_RU/Makefile.am
--- fluxbox-0.9.14.orig/nls/ru_RU/Makefile.am	2005-10-01 09:31:46.000000000 +0400
+++ fluxbox-0.9.14/nls/ru_RU/Makefile.am	2006-04-06 21:55:40.000000000 +0400
@@ -4,23 +4,38 @@
 
 LOCALE_PATH = @LOCALE_PATH@
 NLSTEST = @NLS@
-CLEANFILES = fluxbox.cat
+CLEANFILES = fluxbox.cat fluxbox.utf8.cat Translation.utf8.m
 MAINTAINERCLEANFILES = Makefile.in 
-MFILES = Translation.m
+MFILES = Translation.m Translation.utf8.m
 EXTRA_DIST= $(MFILES)
 
-all-local: fluxbox.cat
-install-data-local: fluxbox.cat
+all-local: fluxbox.cat fluxbox.utf8.cat
+install-data-local: fluxbox.cat fluxbox.utf8.cat
 	@if test x$(NLSTEST) = "x-DNLS"; then \
 		echo "Installing catalog in $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG)"; \
 		$(mkinstalldirs) $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG); \
 		$(INSTALL_DATA) fluxbox.cat $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG); \
+		echo "Installing catalog in $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG).UTF-8"; \
+		$(mkinstalldirs) $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG).UTF-8; \
+		$(INSTALL_DATA) fluxbox.utf8.cat $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG).UTF-8/fluxbox.cat; \
 	fi
 
 uninstall-local:
 	@if test x$(NLSTEST) = "x-DNLS"; then \
 		rm -f $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG)/fluxbox.cat; \
 		rmdir $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG); \
+		rm -f $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG).UTF-8/fluxbox.cat; \
+		rmdir $(DESTDIR)$(LOCALE_PATH)/$(THE_LANG).UTF-8; \
+	fi
+
+%.utf8.m: %.m
+	@if test x$(NLSTEST) = "x-DNLS"; then \
+		iconv -f koi8-r -t utf8 < $< | sed 's/^\$$ codeset=KOI8-R/$ codeset=UTF-8/' > $@; \
+	fi
+
+fluxbox.utf8.cat: Translation.utf8.m
+	@if test x$(NLSTEST) = "x-DNLS"; then \
+		$(gencat_cmd) $@ $<; \
 	fi
 
 fluxbox.cat: Translation.m
diff -xMakefile.in -ru fluxbox-0.9.14.orig/src/FbTk/I18n.cc fluxbox-0.9.14/src/FbTk/I18n.cc
--- fluxbox-0.9.14.orig/src/FbTk/I18n.cc	2005-10-01 09:31:46.000000000 +0400
+++ fluxbox-0.9.14/src/FbTk/I18n.cc	2006-04-06 22:16:21.000000000 +0400
@@ -57,6 +57,10 @@
   #include <stdio.h>
 #endif
 
+#ifdef HAVE_UNISTD_H
+  #include <unistd.h>
+#endif
+
 #include <iostream>
 
 using std::cerr;
@@ -91,6 +95,9 @@
         if (MB_CUR_MAX > 1)
             m_multibyte = true;
 		
+	// save full locale string
+	m_locale_full = m_locale;
+
         // truncate any encoding off the end of the locale
 				
         // remove everything after @
@@ -132,6 +139,17 @@
     catalog_filename += '/';
     catalog_filename += catalog;
 
+#ifdef HAVE_UNISTD_H    
+    string catalog_filename_full = LOCALEPATH;
+    catalog_filename_full += '/';
+    catalog_filename_full += m_locale_full;
+    catalog_filename_full += '/';
+    catalog_filename_full += catalog;
+
+    if (access(catalog_filename_full.c_str(), R_OK) == 0)
+	    catalog_filename = catalog_filename_full;
+#endif
+
 #ifdef MCLoadBySet
     m_catalog_fd = catopen(catalog_filename.c_str(), MCLoadBySet);
 #else // !MCLoadBySet
diff -xMakefile.in -ru fluxbox-0.9.14.orig/src/FbTk/I18n.hh fluxbox-0.9.14/src/FbTk/I18n.hh
--- fluxbox-0.9.14.orig/src/FbTk/I18n.hh	2005-10-01 09:31:46.000000000 +0400
+++ fluxbox-0.9.14/src/FbTk/I18n.hh	2006-04-06 13:00:36.000000000 +0400
@@ -100,6 +100,7 @@
     I18n();
     ~I18n();
     std::string m_locale;
+    std::string m_locale_full;
     bool m_multibyte;
     nl_catd m_catalog_fd;
 
